commit 3e8a10bb21b4c830e1884ff43edd639eae5bf5ce
Author: Jakub Jelinek <jakub@redhat.com>
Date:   Tue Apr 21 17:06:31 2020 +0200

    ubsan: Avoid -Wpadded warnings [PR94641]
    
    -Wpadded warnings aren't really useful for the artificial types that GCC
    lays out for ubsan.
    
    2020-04-21  Jakub Jelinek  <jakub@redhat.com>
    
            PR c/94641
            * stor-layout.c (place_field, finalize_record_size): Don't emit
            -Wpadded warning on TYPE_ARTIFICIAL rli->t.
            * ubsan.c (ubsan_get_type_descriptor_type,
            ubsan_get_source_location_type, ubsan_create_data): Set
            TYPE_ARTIFICIAL.
            * asan.c (asan_global_struct): Likewise.
    
            * c-c++-common/ubsan/pr94641.c: New test.
    
    (cherry picked from commit 73f8e9dca5ff891ed19001b213fd1f6ce31417e3)

diff --git a/gcc/asan.c b/gcc/asan.c
index 9014df19939..220ecf64d6b 100644
--- a/gcc/asan.c
+++ b/gcc/asan.c
@@ -2539,6 +2539,7 @@ asan_global_struct (void)
   TYPE_FIELDS (ret) = fields[0];
   TYPE_NAME (ret) = type_decl;
   TYPE_STUB_DECL (ret) = type_decl;
+  TYPE_ARTIFICIAL (ret) = 1;
   layout_type (ret);
   return ret;
 }
diff --git a/gcc/stor-layout.c b/gcc/stor-layout.c
index d06e88a8135..25377232248 100644
--- a/gcc/stor-layout.c
+++ b/gcc/stor-layout.c
@@ -1314,7 +1314,8 @@ place_field (record_layout_info rli, tree field)
 	 Bump the cumulative size to multiple of field alignment.  */
 
       if (!targetm.ms_bitfield_layout_p (rli->t)
-          && DECL_SOURCE_LOCATION (field) != BUILTINS_LOCATION)
+	  && DECL_SOURCE_LOCATION (field) != BUILTINS_LOCATION
+	  && !TYPE_ARTIFICIAL (rli->t))
 	warning (OPT_Wpadded, "padding struct to align %q+D", field);
 
       /* If the alignment is still within offset_align, just align
@@ -1748,7 +1749,8 @@ finalize_record_size (record_layout_info rli)
 
   if (TREE_CONSTANT (unpadded_size)
       && simple_cst_equal (unpadded_size, TYPE_SIZE (rli->t)) == 0
-      && input_location != BUILTINS_LOCATION)
+      && input_location != BUILTINS_LOCATION
+      && !TYPE_ARTIFICIAL (rli->t))
     warning (OPT_Wpadded, "padding struct size to alignment boundary");
 
   if (warn_packed && TREE_CODE (rli->t) == RECORD_TYPE
diff --git a/gcc/testsuite/c-c++-common/ubsan/pr94641.c b/gcc/testsuite/c-c++-common/ubsan/pr94641.c
new file mode 100644
index 00000000000..b41cb06164d
--- /dev/null
+++ b/gcc/testsuite/c-c++-common/ubsan/pr94641.c
@@ -0,0 +1,11 @@
+/* PR c/94641 */
+/* { dg-do compile } */
+/* { dg-options "-fsanitize=undefined -Wpadded" } */
+
+void foo (void *) __attribute__((nonnull));
+
+void
+bar (void *p)
+{
+  foo (p);
+}
diff --git a/gcc/ubsan.c b/gcc/ubsan.c
index 722f5702612..f859689a8d1 100644
--- a/gcc/ubsan.c
+++ b/gcc/ubsan.c
@@ -229,6 +229,7 @@ ubsan_get_type_descriptor_type (void)
   TYPE_FIELDS (ret) = fields[0];
   TYPE_NAME (ret) = type_decl;
   TYPE_STUB_DECL (ret) = type_decl;
+  TYPE_ARTIFICIAL (ret) = 1;
   layout_type (ret);
   ubsan_type_descriptor_type = ret;
   return ret;
@@ -277,6 +278,7 @@ ubsan_get_source_location_type (void)
   TYPE_FIELDS (ret) = fields[0];
   TYPE_NAME (ret) = type_decl;
   TYPE_STUB_DECL (ret) = type_decl;
+  TYPE_ARTIFICIAL (ret) = 1;
   layout_type (ret);
   ubsan_source_location_type = ret;
   return ret;
@@ -593,6 +595,7 @@ ubsan_create_data (const char *name, int loccnt, const location_t *ploc, ...)
   TYPE_FIELDS (ret) = fields[0];
   TYPE_NAME (ret) = type_decl;
   TYPE_STUB_DECL (ret) = type_decl;
+  TYPE_ARTIFICIAL (ret) = 1;
   layout_type (ret);
 
   /* Now, fill in the type.  */

